CVE-2019-16760

See a problem?
Source
https://nvd.nist.gov/vuln/detail/CVE-2019-16760
Import Source
https://storage.googleapis.com/cve-osv-conversion/osv-output/CVE-2019-16760.json
JSON Data
https://api.osv.dev/v1/vulns/CVE-2019-16760
Aliases
  • GHSA-phjm-8x66-qw4r
Published
2019-09-30T22:15:10Z
Modified
2024-05-22T17:18:03.878353Z
Severity
  • 7.5 (High) CVSS_V3 - CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N CVSS Calculator
Summary
[none]
Details

Cargo prior to Rust 1.26.0 may download the wrong dependency if your package.toml file uses the package configuration key. Usage of the package key to rename dependencies in Cargo.toml is ignored in Rust 1.25.0 and prior. When Rust 1.25.0 and prior is used Cargo may download the wrong dependency, which could be squatted on crates.io to be a malicious package. This not only affects manifests that you write locally yourself, but also manifests published to crates.io. Rust 1.0.0 through Rust 1.25.0 is affected by this advisory because Cargo will ignore the package key in manifests. Rust 1.26.0 through Rust 1.30.0 are not affected and typically will emit an error because the package key is unstable. Rust 1.31.0 and after are not affected because Cargo understands the package key. Users of the affected versions are strongly encouraged to update their compiler to the latest available one. Preventing this issue from happening requires updating your compiler to be either Rust 1.26.0 or newer. There will be no point release for Rust versions prior to 1.26.0. Users of Rust 1.19.0 to Rust 1.25.0 can instead apply linked patches to mitigate the issue.

References

Affected packages

Alpine:v3.19 / rust

Package

Name
rust
Purl
pkg:apk/alpine/rust?arch=source

Affected ranges

Type
ECOSYSTEM
Events
Introduced
0Unknown introduced version / All previous versions are affected
Fixed
1.26.0-r0

Affected versions

1.*

1.10.0-r0
1.10.0-r1
1.16.0-r0
1.16.0-r1
1.16.0-r2
1.16.0-r3
1.16.0-r4
1.16.0-r5
1.17.0-r0
1.17.0-r1
1.17.0-r2
1.17.0-r3
1.18.0-r1
1.19.0-r0
1.20.0-r0
1.21.0-r0
1.21.0-r1
1.22.1-r0
1.23.0-r0
1.23.0-r1
1.24.0-r0
1.24.1-r0
1.25.0-r0

Alpine:v3.20 / rust

Package

Name
rust
Purl
pkg:apk/alpine/rust?arch=source

Affected ranges

Type
ECOSYSTEM
Events
Introduced
0Unknown introduced version / All previous versions are affected
Fixed
1.26.0-r0

Affected versions

1.*

1.10.0-r0
1.10.0-r1
1.16.0-r0
1.16.0-r1
1.16.0-r2
1.16.0-r3
1.16.0-r4
1.16.0-r5
1.17.0-r0
1.17.0-r1
1.17.0-r2
1.17.0-r3
1.18.0-r1
1.19.0-r0
1.20.0-r0
1.21.0-r0
1.21.0-r1
1.22.1-r0
1.23.0-r0
1.23.0-r1
1.24.0-r0
1.24.1-r0
1.25.0-r0

Git / github.com/rust-lang/rust

Affected ranges

Type
GIT
Repo
https://github.com/rust-lang/rust
Events
Introduced
0 Unknown introduced commit / All previous commits are affected
Fixed